import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import javax.swing.*;
import java.util.*;

public class A extends JFrame
{
  private boolean[] K = new boolean[256];   // keys
  private float[][] O = new float[256][10]; // posX posY angle dirX dirY velX velY angVel accX accY
  private int[] T = new int[256];           // timers
  private int[] L = new int[256];           // levels
  private int[][][] P = new int[256][5][2]; // points

  private int Sign()
  {
    if (Math.random() < 0.5) return -1; else return 1;
  }

  private void CreateQuad(float Px, float Py, int Size, int Level)
  {
    int i, j;

    if (Level < 3)
    {
      for (i = 11; i < 251; i++)
      {
        if (T[i] == -1)
        break;
      }
      if (Level == 0)
      {
        O[i][0] = (int)(Math.random() * 640);
        O[i][1] = (int)(Math.random() * 400);
      }
      else
      {
        O[i][0] = (int)(Px + (Math.random() * 15 + 15) * Sign());
        O[i][1] = (int)(Py + (Math.random() * 15 + 15) * Sign());
      }
      O[i][2] = (int)(Math.random() * 360);
      O[i][5] = (int)((Math.random() * 15 + 15) * Sign());
      O[i][6] = (int)((Math.random() * 15 + 15) * Sign());
      O[i][7] = (int)((Math.random() * 30 + 30) * Sign());
      L[i] = Level;
      T[i] = 0;

      for (j = 0; j < 4; j++)
      {
        P[i][j][0] = (int)(Math.cos(j * 90 * 0.0174532) * Size);
        P[i][j][1] = (int)(Math.sin(j * 90 * 0.0174532) * Size);
      }
      P[i][4][0] = P[i][0][0];
      P[i][4][1] = P[i][0][1];
    }
  }

  private boolean PointInPolygon(int Index, float Px, float Py)
  {
    int i, j;
    boolean oddNodes;

    oddNodes = false;
    j = 4;
    for (i = 0; i < 5; i++)
    {
      if (((P[Index][i][1] < Py) && (P[Index][j][1] >= Py)) || ((P[Index][j][1] < Py) && (P[Index][i][1] >= Py)))
      {
        if (P[Index][i][0] + (Py - P[Index][i][1]) / (P[Index][j][1] - P[Index][i][1]) * (P[Index][j][0] - P[Index][i][0]) < Px)
          oddNodes = ! oddNodes;
      }
      j = i;
    }
    return oddNodes;
  }

  private boolean Collision(int BasePoly, int ObjPoly)
  {
    int i;

    for (i = 0; i < 5; i++)
    {
      if (PointInPolygon(BasePoly, P[ObjPoly][i][0], P[ObjPoly][i][1])) return true;
    }
    return false;
  }

  private void TransformPoly(int Index, int Poly)
  {
    int i;
    float axx, axy, ayx, ayy;

    axx = O[Index][3];
    axy = O[Index][4];
    ayx = -axy;
    ayy = axx;
    for (i = 0; i < 5; i++)
    {
      P[Poly][i][0] = (int)(O[Index][0] + axx * P[Index][i][0] + ayx * P[Index][i][1]);
      P[Poly][i][1] = (int)(O[Index][1] + axy * P[Index][i][0] + ayy * P[Index][i][1]);
    }
  }

  private void DrawPoly(Graphics2D g, int Index)
  {
    int i;

    TransformPoly(Index, 254);
    for (i = 0; i < 4; i++)
    {
      g.drawLine((int)(P[254][i][0]), (int)(P[254][i][1]), (int)(P[254][i + 1][0]), (int)(P[254][i + 1][1]));
    }
  }

  private void Update(int Index, float delta)
  {
    T[Index] += delta;
    delta /= 1000;
    O[Index][5] += delta * O[Index][8];
    O[Index][6] += delta * O[Index][9];
    O[Index][0] += delta * O[Index][5];
    O[Index][1] += delta * O[Index][6];
    O[Index][2] += delta * O[Index][7];
  }

  private void HandleKeyEvent()
  {
    int i, j;

    if (K[KeyEvent.VK_LEFT]) O[0][7] = -60;
    if (K[KeyEvent.VK_RIGHT]) O[0][7] = 60;
    if (! K[KeyEvent.VK_LEFT] && ! K[KeyEvent.VK_RIGHT]) O[0][7] = 0;
    if (K[KeyEvent.VK_UP])
    {
      O[0][8] = (float)(Math.cos(O[0][2] * 0.0174532) * 10);
      O[0][9] = (float)(Math.sin(O[0][2] * 0.0174532) * 10);
    }
    if (! K[KeyEvent.VK_UP])
    {
      O[0][8] = 0;
      O[0][9] = 0;
    }

    for (i = 1; i < 11; i++)
      if (T[i] > 2000) T[i] = -1;
    if (K[KeyEvent.VK_SPACE])
    {
      for (i = 1; i < 11; i++)
      {
        if (T[i] != -1) continue;
        if (T[255] > 200 && T[i] == -1)
        {
          T[255] = 0;
          O[i][0] = O[0][0];
          O[i][1] = O[0][1];
          O[i][2] = O[0][2];
          O[i][3] = O[0][3];
          O[i][4] = O[0][4];
          O[i][5] = O[0][5] + O[0][3] * 100;
          O[i][6] = O[0][6] + O[0][4] * 100;
          T[i] = 0;
          int [] px = {10, 17, 17, 10, 10};
          int [] py = {1, 1, -1, -1, 1};
          for (j = 0; j < 5; j++)
          {
            P[i][j][0] = px[j];
            P[i][j][1] = py[j];
          }
          break;
        }
      }
    }
  }

  private void Clipping(int Index)
  {
    if (O[Index][0] < -20) O[Index][0] = 664;
    if (O[Index][0] > 664) O[Index][0] = -20;
    if (O[Index][1] < 0) O[Index][1] = 442;
    if (O[Index][1] > 442) O[Index][1] = 0;
  }

  private void SetDirection(int Index)
  {
    O[Index][3] = (float)(Math.cos(O[Index][2] * 0.0174532));
    O[Index][4] = (float)(Math.sin(O[Index][2] * 0.0174532));
  }

  private void CreateGame(int GameLevel)
  {
    int i;

    for (i = 0; i < 256; i++)
      T[i] = -1;
    O[0][0] = 322;
    O[0][1] = 221;
    O[0][2] = -90;
    O[0][5] = 0;
    O[0][6] = 0;
    O[0][7] = 0;
    T[0] = 0;
    T[255] = 0;
    int [] px = {10, -10, -10, 10, 10};
    int [] py = {0, 5, -5, 0, 0};
    for (i = 0; i < 5; i++)
    {
      P[0][i][0] = px[i];
      P[0][i][1] = py[i];
    }
    for (i = 0; i < GameLevel; i++)
      CreateQuad(0, 0, 36, 0);
  }

  public static void main(String[] args) throws Throwable
  {
    int i, j, k, score, bestscore, damage, level, gamelevel;
    boolean started = false;

    A a = new A();
    a.setSize(new Dimension(646, 432));
    a.setResizable(false);
    a.setTitle("QuadSquad4k");
    a.enableEvents(AWTEvent.KEY_EVENT_MASK);
    a.setVisible(true);

    score = 0;
    bestscore = 0;
    damage = 0;
    gamelevel = 3;
    long lastLoopTime = System.currentTimeMillis();
    BufferedImage buffer = new BufferedImage(646, 432, BufferedImage.TYPE_INT_ARGB);
    Graphics2D g = (Graphics2D)buffer.getGraphics();

    while (! a.K[27])
    {
      g.setColor(new Color(0x000040));
      g.fillRect(0, 0, 646, 432);

      if (a.K[KeyEvent.VK_ENTER]) started = true;
      if (started)
      {
        int delta = (int) (System.currentTimeMillis() - lastLoopTime);
        lastLoopTime = System.currentTimeMillis();

        a.HandleKeyEvent();
        for (i = 0; i < 256; i++)
        {
          if (a.T[i] == -1) continue;

          if (i == 0) g.setColor(Color.white);
          if (i >= 1 && i <= 10) g.setColor(Color.green);
          if (i >= 11 && i <= 250) g.setColor(Color.yellow);
          a.Clipping(i);
          a.SetDirection(i);
          a.Update(i, 3 * delta);
          a.DrawPoly(g, i);
        }

        // life
        g.setColor(Color.gray);
        g.fillRect(530, 40, 100, 10);
        g.setColor(Color.red);
        g.fillRect(530, 40, (int)((200 - damage) / 2), 10);
        // score
        g.setColor(Color.white);
        g.drawString("Score:", 15, 45);
        g.drawString(String.valueOf(score), 55, 45);

        // quads collision with bullets
        for (i = 11; i < 251; i++)
        {
          if (a.T[i] == -1) continue;

          for (j = 1; j < 11; j++)
          {
            if (a.T[j] == -1) continue;

            a.TransformPoly(i, 253);
            a.TransformPoly(j, 254);
            if (a.Collision(253, 254))
            {
              a.T[i] = -1;
              a.T[j] = -1;
              level = a.L[i] + 1;
              for (k = 0; k < 4; k++)
                a.CreateQuad(a.O[i][0], a.O[i][1], 36 >> level, level);
              score += level * 100;
            }
          }
        }
        if (bestscore < score) bestscore = score;

        // ship collision with quads
        j = 0;
        for (i = 11; i < 251; i++)
        {
          if (a.T[i] == -1) continue;

          a.TransformPoly(i, 253);
          a.TransformPoly(0, 254);
          if (a.T[0] > 10000 && a.Collision(253, 254)) damage++;
          if (damage >= 200) started = false;
          j++;
          if (a.T[0] < 10000)
          {
            g.setColor(Color.gray);
            a.DrawPoly(g, 0);
          }
        }

        // level finished?
        if (j == 0)
        {
          if (gamelevel < 10)
          {
            gamelevel++;
            a.CreateGame(gamelevel);
          }
          else started = false;
        }
      }
      else
      {
        score = 0;
        damage = 0;
        gamelevel = 3;
        a.CreateGame(gamelevel);

        g.setColor(Color.white);
        g.drawString("Best Score:", 275, 45);
        g.drawString(String.valueOf(bestscore), 340, 45);
        g.drawString("Enter - Start Game", 275, 220);
      }

      a.getGraphics().drawImage(buffer, 0, 0, null);

      Thread.sleep(10);
    }
    g.dispose();
    System.exit(0);
  }

  public void processEvent(AWTEvent e)
  {
    switch (e.getID())
    {
      case WindowEvent.WINDOW_CLOSING:
        System.exit(0);
      case KeyEvent.KEY_PRESSED:
      case KeyEvent.KEY_RELEASED:
        K[((KeyEvent)e).getKeyCode()] = e.getID() == KeyEvent.KEY_PRESSED;
    }
  }
}
